// List 2-2-2b ボタンを押している間は順次点滅する
// 2015/4/1 Wed Version 1.00
// Copyright (C) 2015 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)

// ピン設定
const int LED0_PIN = 4;    // LED0はデジタルピン4に接続する
const int LED9_PIN = 13;   // LED9はデジタルピン13に接続する
const int BUTTON_PIN = 2;  // プッシュボタンはデジタルピン2に接続する

// 変数
int led;                // LEDn
int buttonState = LOW;  // プッシュボタンの状態：LOWにする

void setup() {
  // LED0からLED9まで繰り返す
  for (led = LED0_PIN; led <= LED9_PIN; led++) {
    pinMode(led, OUTPUT);      // LEDnを出力に設定する
  }
  pinMode(BUTTON_PIN, INPUT);  // プッシュボタンを入力に設定する
  led = LED0_PIN;              // LED0にする
}

void loop(){
  buttonState = digitalRead(BUTTON_PIN);  //  プッシュボタンの状態を読む

  // ボタンを押したときには、
  if (buttonState == HIGH) {
    digitalWrite(led, LOW);   // LEDnを消灯する
    delay(100);               // 0.1秒待つ

    led++;                    // 次のLEDnにする
    // LED9を越えたときには、
    if (led > LED9_PIN) {
      led = LED0_PIN;         // LED0にする
    }

    digitalWrite(led, HIGH);  // LEDnを点灯する
    delay(100);               // 0.1秒待つ
  }
}
