// List 2-2-3 ボタンを離すと少しだけ進み停止する
// 2015/4/1 Wed Version 1.00
// Copyright (C) 2015 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)

// 定数
// ボタンを押したフラグ
#define FLAG_ON 1   // ON
#define FLAG_OFF 0  // OFF

// 乱数の値
const long MIN_RANDOM = 5;   // 乱数の最小値
const long MAX_RANDOM = 10;  // 乱数の最大値

// ピン設定
const int LED0_PIN = 4;    // LED0はデジタルピン4に接続する
const int LED9_PIN = 13;   // LED9はデジタルピン13に接続する
const int BUTTON_PIN = 2;  // プッシュボタンはデジタルピン2に接続する

// 変数
int led;                    // LEDn
int buttonState = LOW;      // プッシュボタンの状態：LOWにする
int buttonFlag = FLAG_OFF;  // ボタンを押したフラグ：OFFにする

void setup() {
  // LED0からLED9まで繰り返す
  for (led = LED0_PIN; led <= LED9_PIN; led++) {
    pinMode(led, OUTPUT);      // LEDnを出力に設定する
  }
  pinMode(BUTTON_PIN, INPUT);  // プッシュボタンを入力に設定する
  led = LED0_PIN;              // LED0にする
  digitalWrite(led, HIGH);     // LEDnを点灯する
    
  // 乱数列を初期化する
  randomSeed(analogRead(0));   // 未接続ピンのノイズを利用する
}

void loop(){
  // 変数
  int i; //  カウンター

  buttonState = digitalRead(BUTTON_PIN);  //  プッシュボタンの状態を読む

  // ボタンを押したときには、
  if (buttonState == HIGH) {
    buttonFlag = FLAG_ON;     // ボタンを押したフラグをONにする
    digitalWrite(led, LOW);   // LEDnを消灯する
    delay(100);               // 0.1秒待つ

    led++;                    // 次のLEDnにする
    // LED9を越えたときには、
    if (led > LED9_PIN) {
      led = LED0_PIN;         // LED0にする
    }

    digitalWrite(led, HIGH);  // LEDnを点灯する
    delay(100);               // 0.1秒待つ
  }

  // それ以外で、ボタンを離したときには、
  else if (buttonFlag == FLAG_ON) {
    // 少しだけ繰り返す
    for (i = 0; i < random(MIN_RANDOM, MAX_RANDOM); i++) {
      digitalWrite(led, LOW);   // LEDnを消灯する
      delay(100 * i);           // 0.1×i秒待つ

      led++;                    // 次のLEDnにする
      // LED9を越えたときには、
      if (led > LED9_PIN) {
        led = LED0_PIN;         // LED0にする
      }

      digitalWrite(led, HIGH);  // LEDnを点灯する
      delay(100 * i);           // 0.1×i秒待つ
    }
    buttonFlag = FLAG_OFF;      // ボタンを押したフラグをOFFにする 
  }
}
