// List 2-3-1 LED表示電圧計を作製する
// 2015/4/1 Wed Version 1.00
// Copyright (C) 2015 by Hiroyuki UCHIDA (Beard UCHIDA) JG1CCL (W3CCL)

// ピン設定
const int LED0_PIN = 4;   // LED0はデジタルピン4に接続する
const int LED9_PIN = 13;  // LED9はデジタルピン13に接続する

// 変数
int led;                  // LEDn
int voltage;              // 電圧
int levelTable[10] = {
  102, 205, 307, 410, 512, 615, 717, 820, 922, 1023};  // 電圧レベルテーブル

void setup() {
  // LED0からLED9まで繰り返す
  for (led = LED0_PIN; led <= LED9_PIN; led++) {
    pinMode(led, OUTPUT);  // LEDnを出力に設定する
  }
}

void loop(){
  // 変数
  int i;                    //  カウンター
  voltage = analogRead(0);  //  電圧を読む

  // 電圧レベルテーブル項目数分繰り返す
  for (i = 0; i < 10; i++) {
    // 電圧が電圧レベル値より小さいときには、
    if (voltage < levelTable[i]) {
      break;                              // 電圧レベルを決定（抜ける）
    }
  }

  // 決定した電圧レベルまで繰り返す
  for (led = 0; led < i; led++) {
    digitalWrite(led + LED0_PIN , HIGH);  // LEDnを点灯する
  }

  // 決定した電圧レベルから最後まで繰り返す
  for (; led < 10; led++) {
    digitalWrite(led + LED0_PIN, LOW);   // LEDnを消灯する
  }
  delay(100);                            // 0.1秒待つ
}
